<template>
	<div>
    <div class="padding margin-top-25">
      <div class="row">
        <div class="columns six">
          <label for="bank_card">Номер карты</label>
          <input type="text"
                 id="bank_card"
                 name="bank_card"
                 v-model="user.bank_card"
                 placeholder="XXXX-XXXX-XXXX-XXXX"
                 v-mask="type_mask"
                 @input="setValue('bank_card')"
                 :keepCharPositions="true"
                 :guide="true"
                 description="bank_card"
                 v-validate="type_valid"
                 @keyup="checkTypeCard"
          >

          <validate-message
            v-show="vErrors.has('bank_card')"
          >{{ vErrors.first('bank_card') }}
          </validate-message>

        </div>
        <div class="columns card-binding two">
          <div class="card-period">Срок действия:</div>
        </div>
        <div class="columns two adaptive-col first-col">
          <label for="monthBankCard">Месяц</label>
          <multiselect v-model="user.monthBankCard"
                       :options="months"
                       :searchable="true"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="monthBankCard"
                       :preserve-search="true"
                       @input="setValue('monthBankCard')"
                       :vValidateRules = "'required'"
                       name="monthBankCard"
          >
          </multiselect>
          <validate-message
            v-show="vErrors.has('monthBankCard')"
          >{{ vErrors.first('monthBankCard') }}
          </validate-message>
        </div>
        <div class="columns two adaptive-col">
          <label for="yearBankCard">Год</label>
          <multiselect v-model="user.yearBankCard"
                       :options="years"
                       :searchable="true"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="yearBankCard"
                       :preserve-search="true"
                       @input="setValue('yearBankCard')"
                       :vValidateRules = "'required'"
                       name="yearBankCard"
          >
          </multiselect>
          <validate-message
            v-show="vErrors.has('yearBankCard')"
          >{{ vErrors.first('yearBankCard') }}
          </validate-message>
        </div>
      </div>
    </div>

    <div class="center">
      <button :disabled="!agree" v-if="showAddBankCard" @click="addBankCard">Привязать карту</button>
    </div>

  <identification v-show="showIdentification"></identification>

	</div>
</template>

<script>
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import OptionSelector from '@/UI/OptionSelector'
  import Identification from './Identification'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_NUMBER_BC, ONLY_NUMERIC } from '@/components/Validators/CustomVeeValidateMessage'
  import cardType from 'credit-card-type'
  import Multiselect from '@/UI/Multiselect'

  export default {
    name: 'bank-card',
    data () {
      return {
        type_valid: 'required|min:19',
        type_mask: '####-####-####-####',
        agree: false,
        creditInfo: false,
        showAddBankCard: true,
        showIdentification: false,
        months: ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'],
        years: ['2018', '2019', '2020', '2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028', '2029']
      }
    },
    mixins: [
      IndicatorRegistration,
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass
    ],
    components: {
      ValidateMessage,
      OptionSelector,
      Identification,
      Multiselect
    },
    methods: {
      checkTypeCard (event) {
        const type = cardType(event.target.value.slice(0, 3))
        if (type[0].lengths[type[0].lengths.length - 1] > 16) {
          this.type_mask = '####-####-####-#######'
        }
        if (type[0].lengths[type[0].lengths.length - 1] === 16) {
          this.type_mask = '####-####-####-####'
        }
      },
      addBankCard () {
        this.creditInfo = true
        this.showAddBankCard = false
        this.showIdentification = true
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_NUMBER_BC)
      this.$validator.localize(ONLY_NUMERIC)
    },
    updated () {
      this.agree = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style>
  .checkbox {
    margin-bottom: 0px !important;
  }
  .red{
    color: #f00;
  }
  .margin-top_-30{
    margin-top: -30px;
  }
  .error{
    background: #fff0ed;
    color: #ff6d4a;
    border-color: #ffd6ce !important;
  }
</style>

